unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ScktComp, StdCtrls, ExtCtrls, Menus, RXShell;

type
  TMyThread=class(TThread)
  private
  protected
    procedure execute; override;
  public
  end;


type
  TForm1 = class(TForm)
    SS1: TServerSocket;
    Timer1: TTimer;
    Panel1: TPanel;
    ServerSocket1: TServerSocket;
    ServerSocket2: TServerSocket;
    Edit1: TEdit;
    Button1: TButton;
    Label1: TLabel;
    Panel2: TPanel;
    Label2: TLabel;
    Edit2: TEdit;
    Button2: TButton;
    end_session: TClientSocket;
    RxTrayIcon1: TRxTrayIcon;
    PopupMenu1: TPopupMenu;
    N2: TMenuItem;
    N1: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    Timer2: TTimer;
    procedure SS1ClientWrite(Sender: TObject; Socket: TCustomWinSocket);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SS1ClientError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure ServerSocket1ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket2ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure end_sessionError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure end_sessionConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure N1Click(Sender: TObject);
    procedure RxTrayIcon1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure N5Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    th:TMyThread;
    procedure newlock;
    procedure newUnlock;

  public

  end;

procedure clearlog;
procedure writelog(msg:string);


var
  tmptime:tdatetime;
  f:textfile;
  Form1: TForm1;
  hmx:Cardinal;
  state, ostate:string;
  flaglock:boolean;
  tmpmsg:string;
  IP_OPER,password:string;
  tmpmsg1:string;
  command:string;
  cmdlist,imgfilelist:TStringList;

implementation

{$R *.DFM}

uses registry, ipform;

Procedure BlockInput(ABlockInput : boolean); stdcall; external 'USER32.DLL';

function RegisterServiceProcessEx(Enable: boolean): boolean;
type TRSP = function (H: THandle; K: dword): dword; stdcall;
var RSP: TRSP;
begin
  @RSP := GetProcAddress(GetModuleHandle(PChar('kernel32.dll')),
                         PChar('RegisterServiceProcess'));
  Result := Assigned(@RSP);
  if Result then begin
    if Enable then Result := (RSP(0, 1) = 1)
              else Result := (RSP(0, 0) = 1);
  end;
end;


procedure TForm1.SS1ClientWrite(Sender: TObject; Socket: TCustomWinSocket);
begin
  command:=command+Socket.ReceiveText;
  if pos(#9#9#9, command)>0 then
  begin
    cmdlist.Text:=command;
    command:='';
    STATE:=cmdlist.Strings[0];
    if STATE='UNLOCK' then newunlock;
    if state='LOCK' then newLOCK;
    if STATE='OFF' then exitwindowsex(EWX_POWEROFF or EWX_FORCE,0);
    if STATE='LOGOFF' then exitwindowsex(EWX_LOGOFF or EWX_FORCE,0);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  r:tregistry;
  sd:string;
begin
  application.Title:='';
  clearlog;
  if paramcount>=1 then
  if uppercase(paramStr(1))='INSTALL' then
  begin
  r:=TRegistry.Create;
  r.RootKey:=HKEY_LOCAL_MACHINE;
  r.OpenKey('SOFTWARE\Microsoft\Windows\CurrentVersion\RunServices',true);
  if r.ReadString('sc')='' then begin
    sd:=ParamStr(0);
    r.WriteString('sc',sd);
  end;
  r.CloseKey;
  r.OpenKey('SOFTWARE\Microsoft\Windows\CurrentVersion\Run',true);
  if r.ReadString('sc')='' then begin
    sd:=ParamStr(0);
    r.WriteString('sc',sd);
  end;
  r.CloseKey;
  r.free;
  closeHandle(hmx);
  terminateprocess(getcurrentprocess,0);
  end
  else
  begin
    r:=TRegistry.Create;
    r.RootKey:=HKEY_LOCAL_MACHINE;
    r.OpenKey('SOFTWARE\Microsoft\Windows\CurrentVersion\RunServices',true);
    if r.ReadString('sc')<>'' then begin
      r.DeleteValue('sc');
    end;
    r.CloseKey;
    r.OpenKey('SOFTWARE\Microsoft\Windows\CurrentVersion\Run',true);
    if r.ReadString('sc')<>'' then begin
      r.DeleteValue('sc');
    end;
    r.CloseKey;
    r.free;
    closeHandle(hmx);
    terminateprocess(getcurrentprocess,0);
  end;

try
  RegisterServiceProcessEx(true);
except
end;
  R:=TRegistry.Create;
  r.RootKey:=HKEY_CURRENT_USER;
  r.OpenKey('Control Panel\Desktop', true);
  state:=r.ReadString('ServisState');
  if state='' then state:='UNLOCK';
  r.CloseKey;
  SS1.Active:=true;
inherited;
if ostate<>'LOCK' then
  exit;
    flaglock:=true;
    showwindow(form1.Handle, SW_MAXIMIZE);
    form1.Show;
//    SendMessage(Application.Handle, WM_SYSCOMMAND, SC_TASKLIST, 0);
    BlockInput(True);
    SystemParametersInfo(SPI_SCREENSAVERRUNNING, 1, nil, 0);

     timer1.Enabled:=true;
//    ShowCursor(false);
    th:=TMyThread.Create(false);
    if tmptime<>0 then
      writelog(#9+'lock'+#9+timetostr(now-tmptime));

end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  SS1.Active:=true;
end;

procedure TForm1.SS1ClientError(Sender: TObject; Socket: TCustomWinSocket;
  ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
  ErrorCode:=0;

end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
label1.Top:=random(screen.Height-label1.Height);
label1.Left:=random(screen.Width-label1.Width);
form1.Paint;
end;

procedure TForm1.newlock;
begin
  if not flaglock then
  begin
    flaglock:=true;
    SendMessage(Application.Handle, WM_SYSCOMMAND, SC_TASKLIST, 0);
    form1.Show;
    showwindow(form1.Handle, SW_MAXIMIZE);
     BlockInput(True);
     SystemParametersInfo(SPI_SCREENSAVERRUNNING, 1, nil, 0);

     timer1.Enabled:=true;
//    ShowCursor(false);
    th:=TMyThread.Create(false);
    if tmptime<>0 then
      writelog(#9+'lock'+#9+timetostr(now-tmptime));
    AssignFile(F, 'c:\windows\system\status.log');
    rewrite(f);
    writeln(f, 'LOCK');
    closefile(f);

  end;
end;

procedure TForm1.newunlock;
begin
  if flaglock then
  begin
    flaglock:=false;
    th.Terminate;
    th.Free;
    ShowCursor(true);
    timer1.Enabled:=false;
    SystemParametersInfo(SPI_SCREENSAVERRUNNING, 0, nil, 0);
     BlockInput(False);
    showwindow(form1.Handle, SW_HIDE);
    showwindow(application.Handle, SW_HIDE);
    writelog(#9+'unlock'+#9+'0');
    tmptime:=now;
    AssignFile(F, 'c:\windows\system\status.log');
    rewrite(f);
    writeln(f, 'UNLOCK');
    closefile(f);
  end;
end;

procedure TMyThread.execute;
BEGIN
while not Terminated do
begin
form1.Left:=0;
form1.top:=0;
sleep(500);
  setcursorpos(form1.Left+(form1.Width div 2), form1.Top+(form1.Height div 2));
end;
END;



procedure TForm1.FormClick(Sender: TObject);
begin
  showmessage('    ');
end;

procedure TForm1.ServerSocket1ClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  STATE:=Socket.ReceiveText;
  tmpmsg:=tmpmsg+state;
  if STATE='.' then
  begin
    showmessage(tmpmsg);
    tmpmsg:='';
  end;
end;

procedure writelog(msg:string);
var
  f:textfile;
begin
{$I-}
  AssignFile(F, 'C:\windows\system\mashine.log');
  FileMode := 0;  {Set file access to read only }
  Reset(F);
  CloseFile(F);
{$I+}
  if IOResult = 0 then
  begin
    AssignFile(F, 'C:\windows\system\mashine.log');
    append(f);
    writeln(f, DatetoStr(now)+#9+timetostr(now)+msg);
    closefile(f);
  end
  else
  begin
    AssignFile(F, 'C:\windows\system\mashine.log');
    rewrite(f);
    writeln(f, DatetoStr(now)+#9+timetostr(now)+#9+'Create logfile'+#9+'0');
    writeln(f, DatetoStr(now)+#9+timetostr(now)+msg);
    closefile(f);
  end;
{$I-}
  AssignFile(F, 'C:\windows\system\mashine.log1');
  FileMode := 0;  {Set file access to read only }
  Reset(F);
  CloseFile(F);
{$I+}
  if IOResult = 0 then
  begin
    AssignFile(F, 'C:\windows\system\mashine.log1');
    append(f);
    writeln(f, DatetoStr(now)+#9+timetostr(now)+msg);
    closefile(f);
  end
  else
  begin
    AssignFile(F, 'C:\windows\system\mashine.log1');
    rewrite(f);
    writeln(f, DatetoStr(now)+#9+timetostr(now)+#9+'Create logfile'+#9+'0');
    writeln(f, DatetoStr(now)+#9+timetostr(now)+msg);
    closefile(f);
  end;
end;

procedure TForm1.ServerSocket2ClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  logstream:tfilestream;
  rt:string;
begin
rt:=Socket.ReceiveText;
  if rt='X' then
  begin
    try
      logstream:=tfilestream.Create('C:\windows\system\mashine.log',fmOpenRead);
      Socket.SendStream(logstream);
    finally
    end;
  end;
  if rt='Z' then
  begin
    try
      logstream:=tfilestream.Create('C:\windows\system\mashine.log',fmOpenRead);
      if Socket.SendStream(logstream) then
        if deletefile('C:\windows\system\mashine.log') then
          writelog(#9+'Reset statistic'+#9+'0');
    finally
    end;

  end;
//All log
  if rt='Y' then
  begin
    try
      logstream:=tfilestream.Create('C:\windows\system\mashine.log1',fmOpenRead);
      Socket.SendStream(logstream);
    finally
    end;
  end;
end;

procedure clearlog;
var
  reg:TRegistry;
begin
{  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_LOCAL_MACHINE;
    Reg.OpenKey('\SOFTWARE\JSC',True);
    if Reg.ReadString('LastDate')<>datetostr(now) then
    begin
      if deletefile('C:\windows\system\mashine.log') then
          writelog(#9+'Reset statistic'+#9+'0');
    end;
    Reg.WriteString('LastDate',datetostr(now));
  finally
    Reg.CloseKey;
    Reg.Free;
  end;}
end;

procedure TForm1.Panel1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (ssShift in shift) and
     (ssAlt in shift) and
     (ssCtrl in shift) and
     (ssLeft in shift) and
     (ssRight in shift)
  then
  begin
    edit1.show;
    button1.show;
  end
  else
  begin
    edit1.hide;
    button1.hide;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if edit1.Text='q' then
  begin
    edit1.hide;
    button1.hide;
    newunlock;
  end
  else
  begin
    edit1.hide;
    button1.hide;
  end;
end;

procedure TForm1.N2Click(Sender: TObject);
begin
if MessageDlg('      ?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes
then
begin
  end_session.Address:=IP_OPER;
  end_session.open;
  tmpmsg1:='END';
end;
end;

procedure TForm1.end_sessionError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  ErrorCode:=0;
end;

procedure TForm1.end_sessionConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  Socket.SendText(tmpmsg1);
  Socket.Close;
end;

procedure TForm1.N1Click(Sender: TObject);
begin
  end_session.Address:=IP_OPER;
  end_session.open;
  tmpmsg1:='TIME';
  end_session.Close;
end;

procedure TForm1.RxTrayIcon1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
//  PopupMenu1.Popup(X, Y);
end;

{
function getimgfile:string;
var
  sr: TSearchRec;
begin
  imgfilelist.Clear;
  if findfirst(imgdir+'*.jpg', faAnyFile, sr)=0 then
  repeat
    imgfilelist.Add(imgdir+sr.Name);
  until findnext(sr)<>0;
  findclose(sr);
  if findfirst(imgdir+'*.gif', faAnyFile, sr)=0 then
  repeat
    imgfilelist.Add(imgdir+sr.Name);
  until findnext(sr)<>0;
  findclose(sr);
  if findfirst(imgdir+'*.bmp', faAnyFile, sr)=0 then
  repeat
    imgfilelist.Add(imgdir+sr.Name);
  until findnext(sr)<>0;
  findclose(sr);

end;
 }

procedure TForm1.N5Click(Sender: TObject);
begin
if InputBox('  ', '  ', '')='zhjckfdkm' then
  close
  else
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
 RxTrayIcon1.Animated:=false;
  RxTrayIcon1.Hide;
  RxTrayIcon1.Show;
 RxTrayIcon1.Animated:=true; 
end;

initialization


imgfilelist:=TStringList.Create;
cmdlist:=TStringList.Create;


  ostate:='UNLOCK';
{$I-}
  AssignFile(F, 'c:\windows\system\status.log');
  FileMode := 0;  {Set file access to read only }
  Reset(F);
  CloseFile(F);
{$I+}
  if IOResult = 0 then
  begin
    AssignFile(F, 'c:\windows\system\status.log');
    reset(f);
    readln(f, ostate);
    closefile(f);
  end
  else
  begin
    AssignFile(F, 'c:\windows\system\status.log');
    rewrite(f);
    writeln(f, ostate);
    closefile(f);
  end;
////////////////////////////////////////

{$I-}
  AssignFile(F, 'c:\windows\system\ip.log');
  FileMode := 0;  {Set file access to read only }
  Reset(F);
  CloseFile(F);
{$I+}
  if IOResult = 0 then
  begin
    AssignFile(F, 'c:\windows\system\ip.log');
    reset(f);
    readln(f, IP_OPER);
    closefile(f);
  end
  else
  begin
    form2:=TForm2.Create(Application);
    form2.ShowModal;
    IP_OPER:=form2.Edit1.Text;
    form2.free;
    AssignFile(F, 'c:\windows\system\ip.log');
    rewrite(f);
    writeln(f, IP_OPER);
    closefile(f);
  end;


  tmptime:=0;
  tmpmsg:='';

  writelog(#9+'Power On'+#9+'0');


finalization
    if tmptime<>0 then
      writelog(#9+'Power Off'+#9+timetostr(now-tmptime));
{    AssignFile(F, 'c:\status.log');
    rewrite(f);
    writeln(f, 'LOCK');
    closefile(f);}

imgfilelist.free;
cmdlist.free;


end.
